# -*- coding: utf-8 -*-
# Copyright 2007-2023 The HyperSpy developers
#
# This file is part of RosettaSciIO.
#
# RosettaSciIO is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# RosettaSciIO is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RosettaSciIO. If not, see <https://www.gnu.org/licenses/#GPL>.

from packaging.version import Version

import numpy as np


def get_numpy_kwargs(array):
    """
    Convenience funtion to return a dictionary containing the `like` keyword
    if numpy>=1.20.

    Note
    ----
    `like` keyword is an experimental feature introduced in numpy 1.20 and is
    pending on acceptance of NEP 35

    """
    kw = {}
    if Version(np.__version__) >= Version("1.20"):
        kw["like"] = array

    return kw
